Index: src/irc/irc-server.c
===================================================================
RCS file: /sources/weechat/weechat/src/irc/irc-server.c,v
retrieving revision 1.105
diff -u -d -p -B -r1.105 irc-server.c
--- src/irc/irc-server.c	16 Jan 2007 14:54:38 -0000	1.105
+++ src/irc/irc-server.c	23 Mar 2007 11:17:05 -0000
@@ -74,26 +74,15 @@ server_init (t_irc_server *server)
 {
     /* user choices */
     server->name = NULL;
-    server->autoconnect = 0;
-    server->autoreconnect = 1;
-    server->autoreconnect_delay = 30;
     server->command_line = 0;
     server->address = NULL;
     server->port = -1;
-    server->ipv6 = 0;
-    server->ssl = 0;
     server->password = NULL;
-    server->nick1 = NULL;
-    server->nick2 = NULL;
-    server->nick3 = NULL;
-    server->username = NULL;
-    server->realname = NULL;
-    server->hostname = NULL;
     server->command = NULL;
-    server->command_delay = 1;
     server->autojoin = NULL;
-    server->autorejoin = 0;
     server->notify_levels = NULL;
+    memset(&server->setting, 0, sizeof(server->setting));
+    memset(&server->isset, 0, sizeof(server->isset));
     
     /* internal vars */
     server->child_pid = 0;
@@ -183,12 +172,12 @@ server_init_with_url (char *irc_url, t_i
             pos2[0] = '\0';
             server->password = strdup (pos2 + 1);
         }
-        server->nick1 = strdup (url);
+        SERVER_SET(server, nick1, strdup(url));
     }
     else
     {
         if ((my_passwd = getpwuid (geteuid ())) != NULL)
-            server->nick1 = strdup (my_passwd->pw_name);
+            SERVER_SET(server, nick1, strdup(my_passwd->pw_name));
         else
         {
             weechat_iconv_fprintf (stderr, "%s: %s (%s).",
@@ -233,18 +222,12 @@ server_init_with_url (char *irc_url, t_i
     
     free (url);
     
-    server->ipv6 = ipv6;
-    server->ssl = ssl;
+    SERVER_SET(server, ipv6, ipv6);
+    SERVER_SET(server, ssl, ssl);
 
     /* some default values */
     if (server->port < 0)
         server->port = DEFAULT_IRC_PORT;
-    server->nick2 = (char *) malloc (strlen (server->nick1) + 2);
-    strcpy (server->nick2, server->nick1);
-    server->nick2 = strcat (server->nick2, "1");
-    server->nick3 = (char *) malloc (strlen (server->nick1) + 2);
-    strcpy (server->nick3, server->nick1);
-    server->nick3 = strcat (server->nick3, "2");
     
     return 0;
 }
@@ -368,18 +351,18 @@ server_destroy (t_irc_server *server)
         free (server->address);
     if (server->password)
         free (server->password);
-    if (server->nick1)
-        free (server->nick1);
-    if (server->nick2)
-        free (server->nick2);
-    if (server->nick3)
-        free (server->nick3);
-    if (server->username)
-        free (server->username);
-    if (server->realname)
-        free (server->realname);
-    if (server->hostname)
-        free (server->hostname);
+    if (server->setting.nick1)
+        free (server->setting.nick1);
+    if (server->setting.nick2)
+        free (server->setting.nick2);
+    if (server->setting.nick3)
+        free (server->setting.nick3);
+    if (server->setting.username)
+        free (server->setting.username);
+    if (server->setting.realname)
+        free (server->setting.realname);
+    if (server->setting.hostname)
+        free (server->setting.hostname);
     if (server->command)
         free (server->command);
     if (server->autojoin)
@@ -448,9 +431,46 @@ server_free_all ()
 }
 
 /*
+ * server_clone: creates a new server, like exising one
+ */
+t_irc_server *
+server_clone(const t_irc_server *orig)
+{
+    t_irc_server *new_server;
+    
+    if ((new_server = server_alloc ()))
+    {
+        new_server->name = strdup(orig->name);
+        new_server->address = strdup(orig->address);
+        new_server->port = orig->port;
+        new_server->password = (orig->password) ? strdup(orig->password) : strdup("");
+        new_server->command = (orig->command) ? strdup(orig->command) : NULL;
+        new_server->autojoin = (orig->autojoin) ? strdup(orig->autojoin) : NULL;
+        new_server->notify_levels = (orig->notify_levels) ? strdup(orig->notify_levels) : NULL;
+        memcpy(&new_server->isset, &orig->isset, sizeof(orig->isset));
+        memcpy(&new_server->setting, &orig->setting, sizeof(orig->setting));
+#define STRDUP_IF_ISSET(setting_) \
+        if (new_server->isset.setting_ && new_server->setting.setting_) \
+            new_server->setting.setting_ = strdup(new_server->setting.setting_);
+        STRDUP_IF_ISSET(nick1);
+        STRDUP_IF_ISSET(nick2);
+        STRDUP_IF_ISSET(nick3);
+        STRDUP_IF_ISSET(username);
+        STRDUP_IF_ISSET(realname);
+        STRDUP_IF_ISSET(hostname);
+#undef STRDUP_IF_ISSET
+    }
+    else
+        return NULL;
+    return new_server;
+}
+
+
+/*
  * server_new: creates a new server, and initialize it
  */
 
+#if 0
 t_irc_server *
 server_new (char *name, int autoconnect, int autoreconnect,
             int autoreconnect_delay, int command_line, char *address,
@@ -480,30 +500,25 @@ server_new (char *name, int autoconnect,
     if ((new_server = server_alloc ()))
     {
         new_server->name = strdup (name);
-        new_server->autoconnect = autoconnect;
-        new_server->autoreconnect = autoreconnect;
-        new_server->autoreconnect_delay = autoreconnect_delay;
+        SERVER_SET(new_server, autoconnect, autoconnect);
+        SERVER_SET(new_server, autoreconnect, autoreconnect);
+        SERVER_SET(new_server, autoreconnect_delay, autoreconnect_delay);
         new_server->command_line = command_line;
         new_server->address = strdup (address);
         new_server->port = port;
-        new_server->ipv6 = ipv6;
-        new_server->ssl = ssl;
+        SERVER_SET(new_server, ipv6, ipv6);
+        SERVER_SET(new_server, ssl, ssl);
         new_server->password = (password) ? strdup (password) : strdup ("");
-        new_server->nick1 = (nick1) ? strdup (nick1) : strdup ("weechat_user");
-        new_server->nick2 = (nick2) ? strdup (nick2) : strdup ("weechat2");
-        new_server->nick3 = (nick3) ? strdup (nick3) : strdup ("weechat3");
-        new_server->username =
-            (username) ? strdup (username) : strdup ("weechat");
-        new_server->realname =
-            (realname) ? strdup (realname) : strdup ("realname");
-        new_server->hostname =
-            (hostname) ? strdup (hostname) : NULL;
-        new_server->command =
-            (command) ? strdup (command) : NULL;
-        new_server->command_delay = command_delay;
-        new_server->autojoin =
-            (autojoin) ? strdup (autojoin) : NULL;
-        new_server->autorejoin = autorejoin;
+        SERVER_SET(new_server, nick1, (nick1) ? strdup (nick1) : strdup ("weechat_user"));
+        SERVER_SET(new_server, nick2, (nick2) ? strdup (nick2) : strdup ("weechat2"));
+        SERVER_SET(new_server, nick3, (nick3) ? strdup (nick3) : strdup ("weechat3"));
+        SERVER_SET(new_server, username, (username) ? strdup (username) : strdup ("weechat"));
+        SERVER_SET(new_server, realname, (realname) ? strdup (realname) : strdup ("realname"));
+        SERVER_SET(new_server, hostname, (hostname) ? strdup (hostname) : NULL);
+        new_server->command = (command) ? strdup (command) : NULL;
+        SERVER_SET(new_server, command_delay, command_delay);
+        new_server->autojoin = (autojoin) ? strdup (autojoin) : NULL;
+        SERVER_SET(new_server, autorejoin, autorejoin);
         new_server->notify_levels =
             (notify_levels) ? strdup (notify_levels) : NULL;
     }
@@ -511,6 +526,7 @@ server_new (char *name, int autoconnect,
         return NULL;
     return new_server;
 }
+#endif
 
 /*
  * server_send: send data to IRC server
@@ -1122,12 +1138,12 @@ server_close_connection (t_irc_server *s
 void
 server_reconnect_schedule (t_irc_server *server)
 {
-    if (server->autoreconnect)
+    if (SERVER_GET(server, autoreconnect))
     {
         server->reconnect_start = time (NULL);
         irc_display_prefix (server, server->buffer, PREFIX_INFO);
         gui_printf (server->buffer, _("%s: Reconnecting to server in %d seconds\n"),
-                    PACKAGE_NAME, server->autoreconnect_delay);
+                    PACKAGE_NAME, SERVER_GET(server, autoreconnect_delay));
     }
     else
         server->reconnect_start = 0;
@@ -1175,7 +1191,7 @@ server_child_read (t_irc_server *server)
             /* adress not found */
             case '1':
                 irc_display_prefix (server, server->buffer, PREFIX_ERROR);
-                if (cfg_proxy_use)
+                if (SERVER_GET(server, proxy_use))
                     gui_printf (server->buffer,
                                 _("%s proxy address \"%s\" not found\n"),
                                 WEECHAT_ERROR, server->address);
@@ -1189,7 +1205,7 @@ server_child_read (t_irc_server *server)
             /* IP address not found */
             case '2':
                 irc_display_prefix (server, server->buffer, PREFIX_ERROR);
-                if (cfg_proxy_use)
+                if (SERVER_GET(server, proxy_use))
                     gui_printf (server->buffer,
                                 _("%s proxy IP address not found\n"), WEECHAT_ERROR);
                 else
@@ -1201,7 +1217,7 @@ server_child_read (t_irc_server *server)
             /* connection refused */
             case '3':
                 irc_display_prefix (server, server->buffer, PREFIX_ERROR);
-                if (cfg_proxy_use)
+                if (SERVER_GET(server, proxy_use))
                     gui_printf (server->buffer,
                                 _("%s proxy connection refused\n"), WEECHAT_ERROR);
                 else
@@ -1602,7 +1618,7 @@ server_child (t_irc_server *server)
     res = NULL;
     res_local = NULL;
     
-    if (cfg_proxy_use)
+    if (SERVER_GET(server, proxy_use))
     {
         /* get info about server */
         memset (&hints, 0, sizeof (hints));
@@ -1639,7 +1655,7 @@ server_child (t_irc_server *server)
             return 0;
         }
         
-        if (pass_proxy(server->sock, server->address, server->port, server->username))
+        if (pass_proxy(server->sock, server->address, server->port, SERVER_GET(server, username)))
         {
             write(server->child_write, "4", 1);
             freeaddrinfo (res);
@@ -1649,15 +1665,15 @@ server_child (t_irc_server *server)
     else
     {
         /* set local hostname/IP if asked by user */
-        if (server->hostname && server->hostname[0])
+        if (SERVER_GET(server, hostname) && SERVER_GET(server, hostname)[0])
         {
             memset (&hints, 0, sizeof(hints));
-            hints.ai_family = (server->ipv6) ? AF_INET6 : AF_INET;
+            hints.ai_family = SERVER_GET(server, ipv6) ? AF_INET6 : AF_INET;
             hints.ai_socktype = SOCK_STREAM;
-            rc = getaddrinfo (server->hostname, NULL, &hints, &res_local);
+            rc = getaddrinfo (SERVER_GET(server, hostname), NULL, &hints, &res_local);
             if ((rc != 0) || !res_local
-                || (server->ipv6 && (res_local->ai_family != AF_INET6))
-                || ((!server->ipv6 && (res_local->ai_family != AF_INET))))
+                || (SERVER_GET(server, ipv6) && (res_local->ai_family != AF_INET6))
+                || ((!SERVER_GET(server, ipv6) && (res_local->ai_family != AF_INET))))
             {
                 write (server->child_write, "5", 1);
                 if (res_local)
@@ -1675,7 +1691,7 @@ server_child (t_irc_server *server)
         
         /* get info about server */
         memset (&hints, 0, sizeof(hints));
-        hints.ai_family = (server->ipv6) ? AF_INET6 : AF_INET;
+        hints.ai_family = SERVER_GET(server, ipv6) ? AF_INET6 : AF_INET;
         hints.ai_socktype = SOCK_STREAM;
         rc = getaddrinfo (server->address, NULL, &hints, &res);
         if ((rc != 0) || !res)
@@ -1685,8 +1701,8 @@ server_child (t_irc_server *server)
                 freeaddrinfo (res);
             return 0;
         }
-        if ((server->ipv6 && (res->ai_family != AF_INET6))
-            || ((!server->ipv6 && (res->ai_family != AF_INET))))
+        if ((SERVER_GET(server, ipv6) && (res->ai_family != AF_INET6))
+            || ((!SERVER_GET(server, ipv6) && (res->ai_family != AF_INET))))
         {
             write (server->child_write, "2", 1);
             if (res)
@@ -1697,7 +1713,7 @@ server_child (t_irc_server *server)
         }
         
         /* connect to server */
-        if (server->ipv6)
+        if (SERVER_GET(server, ipv6))
             ((struct sockaddr_in6 *)(res->ai_addr))->sin6_port = htons (server->port);
         else
             ((struct sockaddr_in *)(res->ai_addr))->sin_port = htons (server->port);
@@ -1745,19 +1761,19 @@ server_connect (t_irc_server *server)
     }
 #endif
     irc_display_prefix (server, server->buffer, PREFIX_INFO);
-    if (cfg_proxy_use)
+    if (SERVER_GET(server, proxy_use))
       {
           gui_printf (server->buffer,
                       _("%s: connecting to server %s:%d%s%s via %s proxy %s:%d%s...\n"),
                       PACKAGE_NAME, server->address, server->port,
-                      (server->ipv6) ? " (IPv6)" : "",
-                      (server->ssl) ? " (SSL)" : "",
+                      SERVER_GET(server, ipv6) ? " (IPv6)" : "",
+                      SERVER_GET(server, ssl) ? " (SSL)" : "",
                       cfg_proxy_type_values[cfg_proxy_type], cfg_proxy_address, cfg_proxy_port,
                       (cfg_proxy_ipv6) ? " (IPv6)" : "");
           weechat_log_printf (_("Connecting to server %s:%d%s%s via %s proxy %s:%d%s...\n"),
                             server->address, server->port,
-                            (server->ipv6) ? " (IPv6)" : "",
-                            (server->ssl) ? " (SSL)" : "",
+                            SERVER_GET(server, ipv6) ? " (IPv6)" : "",
+                            SERVER_GET(server, ssl) ? " (SSL)" : "",
                             cfg_proxy_type_values[cfg_proxy_type], cfg_proxy_address, cfg_proxy_port,
                             (cfg_proxy_ipv6) ? " (IPv6)" : "");
       }
@@ -1766,12 +1782,12 @@ server_connect (t_irc_server *server)
           gui_printf (server->buffer,
                       _("%s: connecting to server %s:%d%s%s...\n"),
                       PACKAGE_NAME, server->address, server->port,
-                      (server->ipv6) ? " (IPv6)" : "",
-                      (server->ssl) ? " (SSL)" : "");
+                      SERVER_GET(server, ipv6) ? " (IPv6)" : "",
+                      SERVER_GET(server, ssl) ? " (SSL)" : "");
           weechat_log_printf (_("Connecting to server %s:%d%s%s...\n"),
                             server->address, server->port,
-                            (server->ipv6) ? " (IPv6)" : "",
-                            (server->ssl) ? " (SSL)" : "");
+                            SERVER_GET(server, ipv6) ? " (IPv6)" : "",
+                            SERVER_GET(server, ssl) ? " (SSL)" : "");
       }
     
     /* close any opened connection and kill child process if running */
@@ -1780,7 +1796,7 @@ server_connect (t_irc_server *server)
     /* init SSL if asked */
     server->ssl_connected = 0;
 #ifdef HAVE_GNUTLS
-    if (server->ssl)
+    if (SERVER_GET(server, ssl))
     {
         if (gnutls_init (&server->gnutls_sess, GNUTLS_CLIENT) != 0)
         {
@@ -1808,10 +1824,10 @@ server_connect (t_irc_server *server)
     server->child_write = child_pipe[1];
     
     /* create socket and set options */
-    if (cfg_proxy_use)
+    if (SERVER_GET(server, proxy_use))
       server->sock = socket ((cfg_proxy_ipv6) ? AF_INET6 : AF_INET, SOCK_STREAM, 0);
     else
-      server->sock = socket ((server->ipv6) ? AF_INET6 : AF_INET, SOCK_STREAM, 0);
+      server->sock = socket (SERVER_GET(server, ipv6) ? AF_INET6 : AF_INET, SOCK_STREAM, 0);
     if (server->sock == -1)
     {
         irc_display_prefix (server, server->buffer, PREFIX_ERROR);
@@ -1892,7 +1908,7 @@ server_auto_connect (int auto_connect, i
          ptr_server = ptr_server->next_server)
     {
         if ( ((command_line) && (ptr_server->command_line))
-            || ((!command_line) && (auto_connect) && (ptr_server->autoconnect)) )
+            || ((!command_line) && (auto_connect) && SERVER_GET(ptr_server, autoconnect)) )
         {
             (void) gui_buffer_new (gui_current_window, ptr_server, NULL,
                                    BUFFER_TYPE_STANDARD, 1);
@@ -1946,7 +1962,7 @@ server_disconnect (t_irc_server *server,
     server->lag_check_time.tv_usec = 0;
     server->lag_next_check = time (NULL) + cfg_irc_lag_check;
     
-    if ((reconnect) && (server->autoreconnect))
+    if ((reconnect) && SERVER_GET(server, autoreconnect))
         server_reconnect_schedule (server);
     else
         server->reconnect_start = 0;
@@ -2173,28 +2189,28 @@ void
 server_print_log (t_irc_server *server)
 {
     weechat_log_printf ("[server %s (addr:0x%X)]\n",      server->name, server);
-    weechat_log_printf ("  autoconnect . . . . : %d\n",   server->autoconnect);
-    weechat_log_printf ("  autoreconnect . . . : %d\n",   server->autoreconnect);
-    weechat_log_printf ("  autoreconnect_delay : %d\n",   server->autoreconnect_delay);
+    weechat_log_printf ("  autoconnect . . . . : %d\n",   SERVER_GET(server, autoconnect));
+    weechat_log_printf ("  autoreconnect . . . : %d\n",   SERVER_GET(server, autoreconnect));
+    weechat_log_printf ("  autoreconnect_delay : %d\n",   SERVER_GET(server, autoreconnect_delay));
     weechat_log_printf ("  command_line. . . . : %d\n",   server->command_line);
     weechat_log_printf ("  address . . . . . . : '%s'\n", server->address);
     weechat_log_printf ("  port. . . . . . . . : %d\n",   server->port);
-    weechat_log_printf ("  ipv6. . . . . . . . : %d\n",   server->ipv6);
-    weechat_log_printf ("  ssl . . . . . . . . : %d\n",   server->ssl);
+    weechat_log_printf ("  ipv6. . . . . . . . : %d\n",   SERVER_GET(server, ipv6));
+    weechat_log_printf ("  ssl . . . . . . . . : %d\n",   SERVER_GET(server, ssl));
     weechat_log_printf ("  password. . . . . . : '%s'\n",
                         (server->password && server->password[0]) ?
                         "(hidden)" : server->password);
-    weechat_log_printf ("  nick1 . . . . . . . : '%s'\n", server->nick1);
-    weechat_log_printf ("  nick2 . . . . . . . : '%s'\n", server->nick2);
-    weechat_log_printf ("  nick3 . . . . . . . : '%s'\n", server->nick3);
-    weechat_log_printf ("  username. . . . . . : '%s'\n", server->username);
-    weechat_log_printf ("  realname. . . . . . : '%s'\n", server->realname);
+    weechat_log_printf ("  nick1 . . . . . . . : '%s'\n", SERVER_GET(server, nick1));
+    weechat_log_printf ("  nick2 . . . . . . . : '%s'\n", SERVER_GET(server, nick2));
+    weechat_log_printf ("  nick3 . . . . . . . : '%s'\n", SERVER_GET(server, nick3));
+    weechat_log_printf ("  username. . . . . . : '%s'\n", SERVER_GET(server, username));
+    weechat_log_printf ("  realname. . . . . . : '%s'\n", SERVER_GET(server, realname));
     weechat_log_printf ("  command . . . . . . : '%s'\n",
                         (server->command && server->command[0]) ?
                         "(hidden)" : server->command);
-    weechat_log_printf ("  command_delay . . . : %d\n",   server->command_delay);
+    weechat_log_printf ("  command_delay . . . : %d\n",   SERVER_GET(server, command_delay));
     weechat_log_printf ("  autojoin. . . . . . : '%s'\n", server->autojoin);
-    weechat_log_printf ("  autorejoin. . . . . : %d\n",   server->autorejoin);
+    weechat_log_printf ("  autorejoin. . . . . : %d\n",   SERVER_GET(server, autorejoin));
     weechat_log_printf ("  notify_levels . . . : %s\n",   server->notify_levels);
     weechat_log_printf ("  child_pid . . . . . : %d\n",   server->child_pid);
     weechat_log_printf ("  child_read  . . . . : %d\n",   server->child_read);
Index: src/irc/irc.h
===================================================================
RCS file: /sources/weechat/weechat/src/irc/irc.h,v
retrieving revision 1.121
diff -u -d -p -B -r1.121 irc.h
--- src/irc/irc.h	16 Mar 2007 08:40:11 -0000	1.121
+++ src/irc/irc.h	23 Mar 2007 11:17:05 -0000
@@ -136,32 +136,64 @@ struct t_irc_outqueue
     t_irc_outqueue *prev_outqueue;  /* pointer to previous message in queue   */
 };
 
+#define SERVER_GET(pserv_, setting_) \
+    ((pserv_)->isset.setting_ ? (pserv_)->setting.setting_ : server_defaults.setting.setting_)
+#define SERVER_SET(pserv_, setting_, value_) \
+    do { (pserv_)->isset.setting_ = 1; (pserv_)->setting.setting_ = (value_); } while(0)
+#define SERVER_UNSET(pserv_, setting_) \
+    do { (pserv_)->isset.setting_ = 0; memset(&(pserv_)->isset.setting_, 0, sizeof((pserv_)->isset.setting_)); } while(0)
+
+extern struct t_irc_server server_defaults;
+
 typedef struct t_irc_server t_irc_server;
 
 struct t_irc_server
 {
     /* user choices */
     char *name;                     /* name of server (only for display)      */
-    int autoconnect;                /* = 1 if auto connect at startup         */
-    int autoreconnect;              /* = 1 if auto reco when disconnected     */
-    int autoreconnect_delay;        /* delay before trying again reconnect    */
     int command_line;               /* server was given on command line       */
     char *address;                  /* address of server (IP or name)         */
     int port;                       /* port for server (6667 by default)      */
-    int ipv6;                       /* use IPv6 protocol                      */
-    int ssl;                        /* SSL protocol                           */
     char *password;                 /* password for server                    */
-    char *nick1;                    /* first nickname for the server          */
-    char *nick2;                    /* alternate nickname                     */
-    char *nick3;                    /* 2nd alternate nickname                 */
-    char *username;                 /* user name                              */
-    char *realname;                 /* real name                              */
-    char *hostname;                 /* custom hostname                        */
     char *command;                  /* command to run once connected          */
-    int command_delay;              /* delay after execution of command       */
     char *autojoin;                 /* channels to automatically join         */
-    int autorejoin;                 /* auto rejoin channels when kicked       */
     char *notify_levels;            /* channels notify levels                 */
+    struct {
+        // server->autoreconnect = 1;
+        // server->autoreconnect_delay = 30;
+        // server->command_delay = 1;
+        // server->autorejoin = 1
+        int autoconnect;            /* = 1 if auto connect at startup         */
+        int autoreconnect;          /* = 1 if auto reco when disconnected     */
+        int autoreconnect_delay;    /* delay before trying again reconnect    */
+        int ipv6;                   /* use IPv6 protocol                      */
+        int ssl;                    /* SSL protocol                           */
+        char *nick1;                /* first nickname for the server          */
+        char *nick2;                /* alternate nickname                     */
+        char *nick3;                /* 2nd alternate nickname                 */
+        char *username;             /* user name                              */
+        char *realname;             /* real name                              */
+        char *hostname;             /* custom hostname                        */
+        int command_delay;          /* delay after execution of command       */
+        int autorejoin;             /* auto rejoin channels when kicked       */
+        int proxy_use;
+    } setting;
+    struct {
+        int autoconnect;
+        int autoreconnect;
+        int autoreconnect_delay;
+        int ipv6;
+        int ssl;
+        int nick1;
+        int nick2;
+        int nick3;
+        int username;
+        int realname;
+        int hostname;
+        int command_delay;
+        int autorejoin;
+        int proxy_use;
+    } isset;
     
     /* internal vars */
     pid_t child_pid;                /* pid of child process (connecting)      */
@@ -359,6 +391,7 @@ extern void server_outqueue_free_all (t_
 extern void server_destroy (t_irc_server *);
 extern void server_free (t_irc_server *);
 extern void server_free_all ();
+extern t_irc_server *server_clone (const t_irc_server *);
 extern t_irc_server *server_new (char *, int, int, int, int, char *, int, int, int,
                                  char *, char *, char *, char *, char *, char *,
                                  char *, char *, int, char *, int, char *);
Index: src/plugins/plugins-interface.c
===================================================================
RCS file: /sources/weechat/weechat/src/plugins/plugins-interface.c,v
retrieving revision 1.45
diff -u -d -p -B -r1.45 plugins-interface.c
--- src/plugins/plugins-interface.c	28 Feb 2007 22:59:47 -0000	1.45
+++ src/plugins/plugins-interface.c	23 Mar 2007 11:17:06 -0000
@@ -785,7 +785,7 @@ weechat_plugin_get_config (t_weechat_plu
                  && (ascii_strcasecmp (option_name, option) == 0)))
             {
                 ptr_option_value = config_get_server_option_ptr (ptr_server,
-                                                                 weechat_options[CONFIG_SECTION_SERVER][i].option_name);
+                                                                 &weechat_options[CONFIG_SECTION_SERVER][i]);
                 if (ptr_option_value)
                 {
                     return weechat_plugin_get_config_str_value (&weechat_options[CONFIG_SECTION_SERVER][i],
@@ -914,24 +914,24 @@ weechat_plugin_get_server_info (t_weecha
 	    if (new_server_info)
 	    {
 		new_server_info->name = (ptr_server->name) ? strdup (ptr_server->name) : strdup ("");
-		new_server_info->autoconnect = ptr_server->autoconnect;
-		new_server_info->autoreconnect = ptr_server->autoreconnect;
-		new_server_info->autoreconnect_delay = ptr_server->autoreconnect_delay;
+		new_server_info->autoconnect = ptr_server->setting.autoconnect;
+		new_server_info->autoreconnect = ptr_server->setting.autoreconnect;
+		new_server_info->autoreconnect_delay = ptr_server->setting.autoreconnect_delay;
 		new_server_info->command_line = ptr_server->command_line;
 		new_server_info->address = (ptr_server->address) ? strdup (ptr_server->address) : strdup ("");
 		new_server_info->port = ptr_server->port;
-		new_server_info->ipv6 = ptr_server->ipv6;
-		new_server_info->ssl = ptr_server->ssl;		
+		new_server_info->ipv6 = ptr_server->setting.ipv6;
+		new_server_info->ssl = ptr_server->setting.ssl;		
 		new_server_info->password = (ptr_server->password) ? strdup (ptr_server->password) : strdup ("");
-		new_server_info->nick1 = (ptr_server->nick1) ? strdup (ptr_server->nick1) : strdup ("");
-		new_server_info->nick2 = (ptr_server->nick2) ? strdup (ptr_server->nick2) : strdup ("");
-		new_server_info->nick3 = (ptr_server->nick3) ? strdup (ptr_server->nick3) : strdup ("");
-		new_server_info->username = (ptr_server->username) ? strdup (ptr_server->username) : strdup ("");
-		new_server_info->realname = (ptr_server->realname) ? strdup (ptr_server->realname) : strdup ("");
+		new_server_info->nick1 = (ptr_server->setting.nick1) ? strdup (ptr_server->setting.nick1) : strdup ("");
+		new_server_info->nick2 = (ptr_server->setting.nick2) ? strdup (ptr_server->setting.nick2) : strdup ("");
+		new_server_info->nick3 = (ptr_server->setting.nick3) ? strdup (ptr_server->setting.nick3) : strdup ("");
+		new_server_info->username = (ptr_server->setting.username) ? strdup (ptr_server->setting.username) : strdup ("");
+		new_server_info->realname = (ptr_server->setting.realname) ? strdup (ptr_server->setting.realname) : strdup ("");
 		new_server_info->command = (ptr_server->command) ? strdup (ptr_server->command) : strdup ("");
-		new_server_info->command_delay = ptr_server->command_delay;
+		new_server_info->command_delay = ptr_server->setting.command_delay;
 		new_server_info->autojoin = (ptr_server->autojoin) ? strdup (ptr_server->autojoin) : strdup ("");
-		new_server_info->autorejoin = ptr_server->autorejoin;
+		new_server_info->autorejoin = ptr_server->setting.autorejoin;
 		new_server_info->notify_levels = (ptr_server->notify_levels) ? strdup (ptr_server->notify_levels) : strdup ("");
 		new_server_info->is_connected = ptr_server->is_connected;
 		new_server_info->ssl_connected = ptr_server->ssl_connected;
